C COMM.INC include file for all PE routines
      IMPLICIT NONE
c      COMMON/VARS/LU,VI,SOIL,ELEV,
c     *		TMAX,TMIN,TA, DEWPT,AIRHUM,EA,UW,
c     *		CLOUD,SOLRAD, FL, SHEAT, PET, RPECIP, SNOW, ET,
c     *		SOILM, RUNOFF, DISCHW
      COMMON/PARAMS/ALB,ALBSN,CR, HEIGHT,LPMAX,GLMAX,R5,CVPD,LWIDTH,
     *           Z0G,RSS,FETCH,ZW,Z0W
      REAL LU,VI,SOIL,ELEV
      REAL TMAX,TMIN,TA, DEWPT,AIRHUM,EA,UW
      REAL CLOUD,SOLRAD, FL, SHEAT, PET, RPECIP, SNOW, ET
      REAL SOILM, RUNOFF, DISCHW

      REAL ALB,ALBSN,CR,HEIGHT,LPMAX,GLMAX,R5,CVPD,LWIDTH,Z0G
      REAL RSS,FETCH,ZW,Z0W
C
C input variables passed to PE functions via COMMON/VAR1/
C  EA      daily average vapor pressure, kPa
C  FL      seasonal reduction factor for maximum LAI, 0 to 1
C  SHEAT   average subsurface heat storage for day, W/m2
C  SNOW  water content of snow on the ground, mm
C  SOLRAD  daily solar radiation on horizontal, MJ/m2
C  TA      mean temperature for the day, degC
C  TMAX    daily maximum air temperature, degC
C  TMIN    daily minimum air temperature, degC
C  UW    daily average wind speed at weather station, m/s
C
C parameters passed to PE functions via COMMON/PAR/
C  ALB     albedo without snow
C  ALBSN   albedo with snow on ground
C  CR      light extinction coefficient for projected LAI
C  CVPD    vpd at which conductance is halved, kPa
C  FETCH   fetch to weather station, m
C  GLMAX   maximum leaf surface conductance for all sides of leaf, m/s
C  HEIGHT  canopy height, m
C  LPMAX   maximum projected leaf area index
C  LWIDTH  average leaf width, m
C  RSS     soil surface resistance, s/m
C  R5      solar radiation at which conductance is halved, W/m2
C  ZW      height of wind sensor at weather station, m
C  Z0G     ground surface roughness, m
C  Z0W     roughness parameter at weather station, m
