      SUBROUTINE ESATF (TA, ES, DELTA)
C     calculates saturated vp and DELTA from temp
C     Murray (1967)
C     input
C        TA      air temperature, degC
C     output
C        ES      vapor pressure at TA, kPa
C        DELTA   dES/dTA at TA, kPa/K
      IMPLICIT NONE
      REAL TA, ES, DELTA
      REAL EXP
      INTRINSIC EXP
      ES = 0.61078 * EXP(17.26939 * TA / (TA + 237.3))
      DELTA = 4098. * ES / (TA + 237.3)**2
      IF (TA .LT. 0.0) THEN
         ES = 0.61078 * EXP(21.87456 * TA / (TA + 265.5))
         DELTA = 5808. * ES / (TA + 265.5)**2
      END IF
      END
