      REAL FUNCTION PMF (AA, DD, DELTA, RA, RC)
C     Penman-Monteith evapotranspiration, W/m2
C     input
C        AA      net energy input, Rn - S, W/m2
C        DD      vapor pressure deficit, kPa
C        DELTA   dEsat/dTair, kPa/K
C        RA      boundary layer resistance, s/m
C        RC      canopy resistance, s/m
C     local constants
C        GAMMA   psychrometric constant, kPa/K
C        CPRHO   volumetric heat capacity of air, J/(K m3)
      IMPLICIT NONE
      REAL AA, DD, DELTA, RA, RC, GAMMA, CPRHO
C
      GAMMA = .067
      CPRHO = 1240
      PMF = (DELTA * AA + CPRHO * DD / RA) /
     *      (DELTA + GAMMA + GAMMA * RC / RA)
      END
