      REAL FUNCTION WNDADJF (ZA, DISP, Z0, FETCH, ZW, Z0W)
C     ratio of wind speed at reference height (above canopy) to
C        wind speed at weather station
C     after Brutsaert (1982)
C     input
C       ZA      reference height, m
C       DISP    height of zero-plane, m
C       Z0      roughness parameter, m
C       FETCH   fetch to weather station, m
C       ZW      height of wind sensor at weather station, m
C       Z0W     roughness parameter at weather station, m
C     local
C       HIBL    height of internal boundary layer, m
C       AA      exponent
C
      INTRINSIC LOG
C     Brutsaert equation 7-39
      HIBL = .334 * FETCH ** .875 * Z0W ** .125
C     Brutsaert equations 7-41 and 4-3
      WNDADJF = LOG(HIBL / Z0W) * LOG((ZA - DISP) / Z0) /
     *          (LOG(HIBL / Z0) * LOG(ZW / Z0W))
      END
