C#######################################################################
C#######################################################################
C#                                                                    ##
C#               PPPP   W           W  BBBBBB   M       M             ##
C#               P   P   W         W   B    B   MM     MM             ##
C#               PPPP     W   W   W    BBBBBB   M M   M M             ##
C#               P         W W W W     B    B   M  M M  M             ##
C#               P          W   W      BBBBBB   M   M   M             ##
C#                                                                    ##
C#                                                                    ##
C#                    PERMAFROST WATER BALANCE MODEL                  ##
C#                     +++++   Version 4.0   +++++                    ##
C# . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .##
C#                                                                    ##
C#                 PWBM VERSION 4.0 CAN BE OBTAINED AT:               ##
C#                                                                    ##
C#                  https://blogs.umass.edu/csrc/pwbm                 ##
C#                                                                    ##
C# . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .##
C#                                                                    ##
C#            *****  PWBM (v4) compute_dzmm subroutine  *****         ##
C#                                                                    ##
C#     NOTE:   See notes in PWBM main routine, file pwbmModel_v4.f    ##
C#                                                                    ##
c***********************************************************************

	subroutine compute_dzmm(zmm, lx, dzmm)
	implicit none
	integer i, lx
	double precision zmm(-5:23), dzmm(23)

	dzmm(1) = zmm(2)/2.0d0
	dzmm(2) = (zmm(3) + zmm(2))/2.0d0 - zmm(2)/2.0d0
	do i = 3, lx
         if (i /= lx) then
            dzmm(i) = (zmm(i+1) - zmm(i-1))/2.0d0 ! thickness of first layer
         else if (i == lx) then  
            dzmm(i) = (zmm(i)-zmm(i-1))/2.0d0
         endif
	enddo
	
	End subroutine compute_dzmm
