C#######################################################################
C#                                                                    ##
C#               PPPP   W           W  BBBBBB   M       M             ##
C#               P   P   W         W   B    B   MM     MM             ##
C#               PPPP     W   W   W    BBBBBB   M M   M M             ##
C#               P         W W W W     B    B   M  M M  M             ##
C#               P          W   W      BBBBBB   M   M   M             ##
C#                                                                    ##
C#                                                                    ##
C#                    PERMAFROST WATER BALANCE MODEL                  ##
C#                     +++++   Version 4.0   +++++                    ##
C# . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .##
C#                                                                    ##
C#                 PWBM VERSION 4.0 CAN BE OBTAINED AT:               ##
C#                                                                    ##
C#                  https://blogs.umass.edu/csrc/pwbm                 ##
C#                                                                    ##
C# . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .##
C#                                                                    ##
C#              *****  PWBM (v4) subroutine: days4month  *****        ##
C#    Subroutine returns the number of days in a month                ##
C#                                                                    ##
C#                                                                    ##
C#     NOTE:   See notes in PWBM main routine, file pwbmModel_v4.f    ##
C#                                                                    ##
c***********************************************************************

      subroutine days4month(iyear,imonth,ndays)
c
c  Subroutine uses inputs of year and month to determine number of days
c  in that month, for that year.  Handles leap years.

      integer iyear,imonth,ndays,monlastday(12)
      data monlastday /31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31/

      ndays = monlastday(imonth)

c  Next several lines handle February in leap years.
      lpyear = 0
      if (mod(iyear,400) .eq. 0 .or. 
     $      mod(iyear,4) .eq. 0 .and. mod(iyear,100) .ne. 0) lpyear = 1

      if (imonth .eq. 2 ) ndays = 28 + lpyear

      return
      end
