!#######################################################################
!#                                                                    ##
!#               PPPP   W           W  BBBBBB   M       M             ##
!#               P   P   W         W   B    B   MM     MM             ##
!#               PPPP     W   W   W    BBBBBB   M M   M M             ##
!#               P         W W W W     B    B   M  M M  M             ##
!#               P          W   W      BBBBBB   M   M   M             ##
!#                                                                    ##
!#                                                                    ##
!#                    PERMAFROST WATER BALANCE MODEL                  ##
!#                     +++++   Version 4.0   +++++                    ##
!# . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .##
!#                                                                    ##
!#                 PWBM VERSION 4.0 CAN BE OBTAINED AT:               ##
!#                                                                    ##
!#                  https://blogs.umass.edu/csrc/pwbm                 ##
!#                                                                    ##
!# . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .##
!#                                                                    ##
!#              *****  PWBM (v4) subroutine: docleaching  *****       ##
!#    Subroutine handles variables for model DOC leaching             ##
!#                                                                    ##
!#                                                                    ##
!#     NOTE:   See notes in PWBM main routine, file pwbmModel_v4.f    ##
!#                                                                    ##
!***********************************************************************

  subroutine mergeDOC(surfpoolrunoff,DOCsurface,baseflow,&
                    DOCsubsurface,DOC4day)

  implicit none

  ! Input Variables
  integer iwrite
  real*8 :: surfpoolrunoff,DOCsurface,baseflow,DOCsubsurface
!
! Output Variables... ! soil layer DOC and weighted subsurface DOC 
  real*8 :: DOC4day  
!
!-----------------------------------------------------------------------
!
  if (DOCsurface .gt. 0.0d0 .and. DOCsubsurface .le. 0.0d0) then
     DOC4day = DOCsurface
  else if (DOCsurface .le. 0.0d0 .and. DOCsubsurface .gt. 0.0d0) then
     DOC4day = DOCsubsurface
  else if (DOCsurface .gt. 0.0d0 .and. DOCsubsurface .gt. 0.0d0) then
     DOC4day = DOCsurface + DOCsubsurface
  else if (DOCsurface .le. 0.0d0 .and. DOCsubsurface .le. 0.0d0) then   
     DOC4day = -999.9d0
  else
     print*, 'Error with If check'
  endif

  if (baseflow .gt. 0.0d0 .and. DOC4day .le. 0.0d0) DOC4day = -888.8d0
  
end subroutine mergeDOC
