 
C#######################################################################
C#######################################################################
C#                                                                    ##
C#               PPPP   W           W  BBBBBB   M       M             ##
C#               P   P   W         W   B    B   MM     MM             ##
C#               PPPP     W   W   W    BBBBBB   M M   M M             ##
C#               P         W W W W     B    B   M  M M  M             ##
C#               P          W   W      BBBBBB   M   M   M             ##
C#                                                                    ##
C#                                                                    ##
C#                    PERMAFROST WATER BALANCE MODEL                  ##
C#                     +++++   Version 4.0   +++++                    ##
C# . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .##
C#                                                                    ##
C#                 PWBM VERSION 4.0 CAN BE OBTAINED AT:               ##
C#                                                                    ##
C#                  https://blogs.umass.edu/csrc/pwbm                 ##
C#                                                                    ##
C# . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .##
C#                                                                    ##
C#    NOTE:                                                           ##
C#    -----                                                           ##
C#    BY DOWNLOADING THE PERMAFROST WATER BALANCE MODEL (PWBM)        ##
C#    PROGRAM YOU AGREE TO THE TERMS OF USE AS DEFINED IN THE         ##
C#    LICENSE DOCUMENT:                                               ##
C#  https://www.geo.umass.edu/climate/papers2/license_PWBM_2019.pdf   ##
C#                                                                    ##
C#    Copyright © 2019. The Climate System Research Center (“CSRC”).  ##
C#      All Rights Reserved.                                          ##
C#                                                                    ##
C# . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .##      
C#    NOTE:                                                           ##
C#    -----                                                           ##
C#    Care should be taken to understand all input parameters and     ##
C#    file paths defined in file <pwbm.initialize_v4.txt>.            ##
C#                                                                    ##
C#    If you modify this program in any way, please do not            ##
C#    distribute the modified version under the name                  ##
C#               Permafrost Water Balance Model                       ##
C#######################################################################
C#######################################################################
C#                                                                    ##
C#   NOTE:  THE DEFAULT ARRAY DIMENSIONS SUPPORT UP TO 579 GRIDS      ##
C#                                                                    ##
C#######################################################################
C#######################################################################

      program pwbm
      implicit none

      integer narray,nbasins,ncells,kyr,iyrindex,inum
      parameter (narray=579,nbasins=1289)
      real r_lat,r_lon,rlat(narray),rlon(narray)
      integer length1,length2,length,imon,lengthout,jspringflag
      integer i,j,k,l,m,mm,nn,icell,irec,ii,jj,ntime,ibad,julday,iunit
      integer iindx(narray),jindx(narray),id,id2,ibasin,idrain2,iyr
      integer iyear,imonth,i_day,iWinterFlag
      integer ihave_basinout,init,nspinup,intrnl_bas,idata
      integer ifrstyr,ilstyr,iday,ndays,nmons,ivegcov,igetsubbasin
      integer nyear,numdays,imth,idoy,jsnowwatflag,jsurfwatcount(narray) 
      integer ntotdays,ivegitation(narray),n_days,isoilclass,iwrite
      integer igetcell,navs,iflag,iwatbody(narray),id4wale(narray)
      integer monlastday(12),lastday,ihave_basin(nbasins),ntotmons
      integer ioutyr1,ioutmon1,ioutyr2,ioutmon2,idailyout(20),mcell
      integer monthlyout(20),ievapfunc,iveg1(narray),noyes_spinup
      integer igetbasin,id4CALM(narray),ID_ToCell,idtocell(narray)
      integer irow,icol,irow_togrid(narray),icol_togrid(narray)
      integer ihavesub(narray),idRIMS(narray),jvalidGrid(narray)
      integer irecnum,ioutletFlag(narray),id4northAK(narray)
      parameter(navs=10) 
      dimension ihave_basinout(narray),intrnl_bas(79),idrain2(narray)
      dimension id(narray+1),id2(narray+1),ibasin(narray)
      data monlastday /31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31/
      real*8 evap,water4Land,sum,km2mm,globe_cloud,rmissing,rmissing2
      real*8 total_initial_water,total_land_water,terrestrialWater
      real*8 potent_et2,h_d,prcp,precip,prain,psnow,sum2ocean,totjunk
      real*8 export2ocean,watbodysnowprev,watbodysnow,watbodystoreprev
      real*8 watbody_snow,watbody_wat,excess,rsum,readPrcp
      real*8 tminvals,tmaxvals,vaporvals,windvals,radvals,watbodystore
      real*8 tmin,tmax,vaporpress,windsp,radnet,years,watbodywatprev
      real*8 snowwatprev,snowwattoday,wsnow,temp,tair,tsnow_cutoff
      real*8 FL,sheat,rLAI,watbodywat,sum_watbodystore,solarrad,totsnow
      real*8 sum_p,sum_wsnow,sum_et,sum_runoff,sum_intrnl,potent_et
      real*8 basin_outlet,sum2ocean_alltime,total,snowprev,effective_e
      real*8 snowtoday,snowpack,sum_snowpk,snowretain,snowrelease,area
      real*8 snow_subl,snowpet,sum_snowsubl,PminusE,snowmelt,avail_wat
      real*8 surf_evap,sum_surfevap,rad_2_melt,rad_melt,fracLand(narray)
      real*8 temp_array(3,narray),sum2,tavg,soildensity,check
      real*8 soildepth(narray),sumtair2(narray),ajunk(0:23),elev(narray)
      real*8 rootdepth_input,rootdepth(narray),watbodyrunoff,soilwatvol
      real*8 root_depth,fieldcapacity,sumprecip,sum_TWS,densitysurfC
      real*8 root_depth_physical(narray),soil_depth,rNPPvals,rNPP
      real*8 root_porosity(narray),rootdepthphysical,surfaceC(2020)
      real*8 surfaceConduct,surface_conduct,surface_conduct_factor
      real*8 sumtair(narray),soilporosity,wiltingpoint,infiltration
      real*8 field_capac(narray),zfrzmax(narray),a,b,c,d,e
      real*8 abs_sumtair,wilt_point(narray),field_capac_percent(narray)
      real*8 wilt_point_percent(narray),runoff_merged,evap_merged
      real*8 rootbaseflowfact,deepbaseflowfact,diff,sumro,sumatocean
      real*8 sumtair_prev,sumpet,sumsnow,sumsubl,sumavailwat,sumsurfevap
      real*8 sumrunoff,sumriver,sumet,summerthaw,sumbas
      real*8 bulkdensity,thermconddry,extentMin(narray),runoff_volume
      real*8 heatcapdry,heat_capdry,extentMax(narray),discharge_mm
      real*8 bulk_dens,therm_conddry,therm_condpeatdry
      real*8 snow_water_change,snow_density,snow_timestep,snow_age
      real*8 snow_age_prev,snow_thcnd,snow_heatc,snowage(narray)
      real*8 peatdensity,soilcarbon,hcapacitypeatdry,totsnowprev
      real*8 basin_area(nbasins),deepconduct,varjunk
      real*8 conduct_av,conduct_sum,conductpeat_av,conductpeat_sum
      real*8 changesnow,prev_TWS,prev_water4Land,sum_water4Land
      real*8 riverVolume(narray),riverVolumeprev(narray),carbonLeached
      real*8 runoff1(narray,366),evap1(narray,366),baseflow1(narray,366)
      real*8 baseflowDOC1(narray,366)
      real*8 snowwateq1(narray,366),snowwater(narray,366)
      real*8 monthrunoff(narray,12),monthevap(narray,12)
      real*8 monthsnowdepth(narray,12),monthbaseflow(narray,12)
      real*8 monthprcp(narray,12),monthswe(narray,12),pfactor(12)
      real*8 monthsub(narray,12),snowice(narray,366)
      real*8 snowmelt1(narray,366),monthmeltwat(narray,12)
      real*8 monthsoilval(narray,12),runoff4routing(narray)

! New variables added in 2020      
      real*8 densityC1,densityC2,densityC3,production_k,decomp_k
      real*8 DOCsubsurface,DOC4day,DOC_stream(narray,31),DOCsurface
      real*8 carbondensity(3,narray)
      real*8 param1,param2,param3,param4,param5
      real*8 param1a,param2a,param3a,param4a,param5a
      real*8 param1b,param2b,param3b,param4b,param5b
      real*8 production_k_sub_mack,production_k_sub_yukon
      real*8 production_k_sub_other
      real*8 production_k_surf_mack,production_k_surf_yukon
      real*8 production_k_surf_other
      real*8 decomp_k_sub_mack,decomp_k_sub_yukon,decomp_k_sub_other
      real*8 decomp_k_surf_mack,decomp_k_surf_yukon,decomp_k_surf_other
      real*8 siteprcp(2030,366),sitetair(2030,366),sitewind(2030,366)
      real snow4pet,pmdayf,sngl_lai,sngl_snow,sngl_FL,sngl_wind,sngl_rad
      real sngl_tair,sngl_vap,sngl_sheat,sngl_tmax,sngl_tmin
      real sngl_lat,sngl_lon,laivals
      dimension evap(366,narray),basin_outlet(narray),temp(366,narray)
      dimension prcp(366,narray),wsnow(narray),snowpack(narray)
      dimension tminvals(366,narray),tmaxvals(366,narray)
      dimension vaporvals(366,narray),windvals(366,narray)
      dimension radvals(366,narray),laivals(12,31,narray)
      dimension summerthaw(narray),bulk_dens(narray)
      dimension therm_conddry(narray),heat_capdry(narray)
      dimension soilcarbon(narray),rNPPvals(narray) 
      dimension sumbas(navs,nbasins),conductpeat_sum(narray)
      dimension conduct_sum(narray),watbodywat(narray)
      dimension watbodysnow(narray)
      character header*60,datestring*7,datestring2*11,fmt*40
      character dataname*40,yrstring*4
      character lainame*100,fname*100,fname2*100,fname3*100    
      character runoffname*60,domain_file*100
      character*100 rootfile,carbonfile,temvegfile,soiltextfile
      character*100 watbodyfile,freshsnowfile,snowclassfile
      character*100 peatfracfile,elevfile,carbondensityfile1
      character*100 carbondensityfile2,carbondensityfile3
      character*100 spinupfile,prcppath,temppath,altpath,outpath,npppath
      character*100 tmaxpath,tminpath,vaporpath,windpath,radpath,laipath
      character  yearchk*4,yearstr*4,homedir*100,str1*120
      logical printflag,read_evapdat,read_penmandat,read4energy
      logical ET_SWITCH,INFILTRATION_SWITCH,ONECELL_SWITCH,ALASKA_SWITCH
      logical BASIN_SWITCH,SUBBASIN_SWITCH,NorthAK_SWITCH,Elson_SWITCH
      data read_evapdat,read4energy /.false.,.false./   
      data ET_SWITCH,INFILTRATION_SWITCH /.true., .true./ ! true = run process
      data ONECELL_SWITCH,ALASKA_SWITCH /.false.,.false./
      data BASIN_SWITCH,SUBBASIN_SWITCH /.false.,.false./
      data NorthAK_SWITCH,Elson_SWITCH /.false.,.true./
      parameter(igetcell=1,igetbasin=1213,igetsubbasin=0790) ! 3604 7115 
!   if ONECELL_SWITCH true, run only for grid set in igetcell

      INCLUDE 'pwbm.soil_temperature.h'
                                                        !Global variables
      real*8  soil_temperature(narray,sx:lx+1) !Soil temperature
      real*8  stemp_4layer(sx:lx+1)          ! vector for one grid
      real*8  soil_liqfraction(narray,sx:lx+1) !Liquid water fraction in soil
      real*8  soil_liqfraction_prev(narray,sx:lx+1) !Liquid water fraction in soil at the previous time step
      integer soil_phchange(narray,sx:lx+1) !Layers where the phase change occurs
      real*8  soil_saturation0(narray,sx:lx+1) !Fraction of pore space filled with liquid water at the previous time step
      real*8  soil_saturation1(narray,sx:lx+1) !Fraction of pore space filled with liquid water at the current time step

      real*8  soil_x(narray,sx:lx) 

      real*8  dry_soil_thcnd(narray,lx)       !Thermal conductivity of dry soil
      real*8  dry_soil_heatc(narray,lx)       !Heat capacity of dry soil
      real*8  soil_freezing_pd(narray,lx)     !Global array
      real*8  soil_cleaness(narray,lx)     


      real*8  soil_timestep(narray)           !Automatically updated timestep 
      integer soil_gc(narray)                 !Automatically updated counter of converged iterations

      integer soil_frozen(narray)             !Check if the soil column is entirely frozen
      real*8  soil_front(narray)              !Location of the freezing front closest to the surface
      real*8  soil_ALD(narray)                !The active layer depth
      integer isoil_ALD(narray)               !XREF's node of the active layer
      real*8  soil_ALD_T(narray)              !The soil temperature at the active layer depth
      real*8  soil_ALD_tmp(narray)            !The soil temperature at the active layer depth
      real*8  soil_time(narray)               !Time in soil. For testing

      !SNOW	        
      real*8  soil_frsnow(narray)             !Fresh snow density, according to M.Sturm
      integer soil_sn(narray)                 !Number of the first snow node in the grid
      real*8 soil_snowheight(narray)
      real*8 soil_snowthcnd(narray)
      real*8 soil_snowheatc(narray)
      real*8 soil_snowdensity(narray)

      real*8 sfreezing_pd,scleaness         
      real*8 depth4layer(-4:0),thickness4depth(-4:0)
      real*8 depth4interface(-5:0),frac_bottom
      integer isnowclass(narray)
      integer iwrite_tmp
     
      real*8  dzmm(lx)
      character*2 Sstr(sx:lx),Wstr(sx:lx)

      !INFILTRATION into the frozen soil
      real*8 SS0, SS1, max_dw, rel_dw

      integer ipeatzones,mlayers
      real*8 soilnode(sx:lx),soilwat,soilice,soilDOC(0:lx)
      real*8 soilDOC4layer(0:lx,narray)
      real*8 soil_water(narray),soil_ice(narray)
      real*8 watertoday(sx:lx),water4layer(sx:lx,narray)
      real*8 water4layerprev(sx:lx),icetoday(sx:lx)
      real*8 ice4layer(sx:lx,narray),ice4layerprev(sx:lx)
      real*8 thermcondlayer(lx),peatfraction(1:lx)
      real*8 peatfractionarray(lx,narray),upper_soilice,upper_soilwat
      real*8 porositycombined(lx),porosityarray(lx,narray)
      real*8 porosity_4layer(lx),fcapacitycombined(lx)
      real*8 fcapacity_4layer(lx),fcapacityarray(lx,narray)
      real*8 evap4surfacepool,surfpoolrunoff,evap_lake_watbody
      real*8 soilwatNEW,soiliceNEW,soilwatprevNEW,soiliceprevNEW
      real*8 baseflow,overlandrunoff,transpiration,sum_soilwaterice
      real*8 soilwatdomain,soilicedomain,capacity_4layer(sx:lx)
      real*8 runoff,riverwat,downstreamQ,change4river,riverwater(narray)
      real*8 riverwater_initial,riverwatprev,river_upstream_input
      real*8 river_upstream_prev(0:narray),basin_outletNEW(narray)
      real*8 sum_riverwater,hk_sat(lx),psi_sat(lx),beta_combined(lx)
      real*8 hksatcombined(lx,narray),psisatcombined(lx,narray)
      real*8 betacombined(lx,narray),snowdensity(narray,5),depth_newsnow
      real*8 ro_nsnow,Utau_t,ro_soft_snow,ro_soft_snow_old,frac_new
      real*8 rho_depthhoar,ro_snow_grid,snowThermCondUp,snowThermCondBot

      data soilnode/-0.696D0,-0.402D0,-0.292D0,-0.164D0,-0.070D0,
     $    0.000D0,0.01D0,0.03D0,0.08D0,0.13D0,0.23D0,0.33D0,0.45D0,
     $  0.55D0,0.70D0,1.05D0,1.40D0,1.75D0,2.25D0,2.75D0,3.25D0,4.75D0, 
     $  7.25D0,14.0D0,22.0D0,31.0D0,40.0D0,50.0D0,60.00D0/

      
      do icell=1,narray
        call initialize_soil(soil_temperature(icell,:),
     $                       soil_liqfraction(icell,:),
     $     soil_timestep(icell),soil_gc(icell),
     $     soil_sn(icell),soil_time(icell),soil_front(icell),soilnode)

           soil_phchange(icell,:)=0
           soil_ALD(icell)=0.0d0
           isoil_ALD(icell)=-1
           soil_ALD_T(icell)=-999.9D0
           soil_ALD_tmp(icell)=0.0D0
      enddo

C  DEFINE CONSTANTS
      km2mm=1.0d-6
 
C OPEN CONTROL FILE AND READ RECORDS
      call getenv('HOME', homedir)
      inum = index(homedir, ' ') - 1
      OPEN(11,FILE='pwbm.initialize_v4.txt')
      READ (11,'(a100)') str1
      length1 = index (str1, ' ') - 1
      domain_file = str1(1:length1) 
      READ (11,'(a100)') str1
      length1 = index (str1, ' ') - 1
      elevfile = str1(1:length1) 
      READ (11,'(a100)') str1
      length1 = index (str1, ' ') - 1
      rootfile = str1(1:length1)
      READ (11,'(a100)') str1
      length1 = index (str1, ' ') - 1
      carbonfile = str1(1:length1)
      READ (11,'(a100)') str1
      length1 = index (str1, ' ') - 1
      temvegfile = str1(1:length1)
      READ (11,'(a100)') str1
      length1 = index (str1, ' ') - 1
      watbodyfile = str1(1:length1)
      READ (11,'(a100)') str1
      length1 = index (str1, ' ') - 1
      freshsnowfile = str1(1:length1)
      READ (11,'(a100)') str1
      length1 = index (str1, ' ') - 1
      snowclassfile = str1(1:length1)
      READ (11,'(a100)') str1
      length1 = index (str1, ' ') - 1
      soiltextfile = str1(1:length1)
      READ (11,'(a100)') str1
      length1 = index (str1, ' ') - 1
      peatfracfile = str1(1:length1)
      READ (11,'(a100)') str1
      length1 = index (str1, ' ') - 1
      carbondensityfile1 = str1(1:length1)
      READ (11,'(a100)') str1
      length1 = index (str1, ' ') - 1
      carbondensityfile2 = str1(1:length1)
      READ (11,'(a100)') str1
      length1 = index (str1, ' ') - 1
      carbondensityfile3 = str1(1:length1)
      READ (11,'(a100)') str1
      length1 = index (str1, ' ') - 1
      spinupfile = str1(1:length1)
      length2 = index (str1, 'spinup.') - 1
      READ (11,'(a100)') str1
      length1 = index (str1, ' ') - 1
      prcppath = str1(1:length1) 
      READ (11,'(a100)') str1
      length1 = index (str1, ' ') - 1
      temppath = str1(1:length1) 
      READ (11,'(a100)') str1
      length1 = index (str1, ' ') - 1
      altpath = str1(1:length1)
      READ (11,'(a100)') str1
      lengthout = index (str1, ' ') - 1
      outpath = str1(1:lengthout)
       
      READ (11,'(a100)') str1
      length1 = index (str1, ' ') - 1
      tmaxpath = str1(1:length1)
      READ (11,'(a100)') str1
      length1 = index (str1, ' ') - 1
      tminpath = str1(1:length1)
      READ (11,'(a100)') str1
      length1 = index (str1, ' ') - 1
      vaporpath = str1(1:length1)
      READ (11,'(a100)') str1
      length1 = index (str1, ' ') - 1
      windpath = str1(1:length1) 
      READ (11,'(a100)') str1
      length1 = index (str1, ' ') - 1
      radpath = str1(1:length1) 
      READ (11,'(a100)') str1
      length1 = index (str1, ' ') - 1
      laipath = str1(1:length1)
      READ (11,'(a100)') str1
      length1 = index (str1, ' ') - 1
      npppath = str1(1:length1)

      READ(11,*)                      ! read blank line in init file
      READ(11,*) area                 
      READ(11,*) peatdensity
      READ(11,*) therm_condpeatdry
      READ(11,*) hcapacitypeatdry
      READ(11,*) tsnow_cutoff
      READ(11,*) snowretain
      READ(11,*) snowrelease
      READ(11,*) infiltration    
      READ(11,*) rootbaseflowfact,deepbaseflowfact
      READ(11,*) production_k_sub_mack,production_k_sub_yukon,
     $     production_k_sub_other
      READ(11,*) production_k_surf_mack,production_k_surf_yukon,
     $     production_k_surf_other
      READ(11,*) decomp_k_sub_mack,decomp_k_sub_yukon,decomp_k_sub_other
      READ(11,*) decomp_k_surf_mack,decomp_k_surf_yukon,
     $     decomp_k_surf_other
      READ(11,*) ievapfunc
      READ(11,*) noyes_spinup
      READ(11,*) nspinup
      READ(11,*)                      ! read blank line in itit file

      READ(11,*) ifrstyr
      READ(11,*) ilstyr
      READ(11,*) ioutyr1,ioutmon1
      READ(11,*) ioutyr2,ioutmon2
      READ(11,*) idailyout(1)
      READ(11,*) idailyout(2)
      READ(11,*) idailyout(3)
      READ(11,*) idailyout(4)
      READ(11,*) idailyout(5)
      READ(11,*) idailyout(6)
      READ(11,*) idailyout(7)
      READ(11,*) idailyout(8)
      READ(11,*) idailyout(9)
      READ(11,*) idailyout(10)
      READ(11,*) monthlyout(1)
      READ(11,*) monthlyout(2)
      READ(11,*) monthlyout(3)
      READ(11,*) monthlyout(4)
      READ(11,*) monthlyout(5)
      READ(11,*) monthlyout(6)
      READ(11,*) monthlyout(7)
      READ(11,*) monthlyout(8)
      CLOSE(11) 

      write(yearchk,'(i4)') ifrstyr
      if (yearchk .ne. spinupfile(length2+8:length2+11)) then
         write(6,*) 
     $'** ERROR: mismatched spinup file and first year of simulation **'
         print*, ifrstyr, yearchk, spinupfile(length2+8:length2+11)
         stop
      endif 

      if (ievapfunc .ge. 2) then
         read_penmandat = .true.
      else
         read_penmandat = .false.
      endif

      open(60,file='param.txt')
      read(60,*) param1a,param2a,param3a,param4a,param5a
      read(60,*) param1b,param2b,param3b,param4b,param5b
      close(60)	

      
!    reading the domain file, define the domain/sites/basin to run the model
      open (unit=14,file=domain_file)

c  Read drainage cell information from table.  Indicies for
c  latitude and longitude are read in from file.  j is for lat, i for
c  lon. They are not used in model.  Fill arrays for basin info.
      read(14,*) header                 ! skipping header/label
      do icell=1, 100000
         if (icell .gt. narray) exit
         read (14,16,end=99) id(icell), id2(icell), 
     $          r_lat, r_lon, idrain2(icell), ibasin(icell)
16       format (2i8,2f12.6,2i8)
         rlat(icell) = r_lat
         rlon(icell) = r_lon
         id4wale(icell) = 0
         id4CALM(icell) = 0
         jvalidGrid(icell) = 0
      enddo
      close(14)   
 99   ncells = icell - 1
      print*, ncells, ' domain records read'

c  Initialize all disch(grid#) to zero. grid ID # went from 62242 to 4446
c  for previous geographic grid.  Now go from 1 to 39926 for EASE drainage 
      do m=0, ncells            ! grid ID # go from 1 to 39926
         river_upstream_prev(m) = 0.0d0
      enddo
      do m=1, ncells            
         ihave_basinout(m) = 0  
         basin_outlet(m) = 0.0d0
         basin_outletNEW(m) = 0.0d0
      enddo
      
c  Sum up basin areas for each basin in domain.  Then calculate the basin
c  area for each of the basins.  Also determine which numbers (1-nbasins) are
c  designated as a basin.  For example, Ob is 5 and Yenisei is 7
      do m = 1, nbasins
         basin_area(m) = 0.0d0
         ihave_basin(m) = 0
      enddo
      do icell = 1, ncells       ! next line sums area for each basin
         basin_area(ibasin(icell)) = basin_area(ibasin(icell)) + area
         if (basin_area(ibasin(icell)) .gt. 0.0d0) 
     $             ihave_basin(ibasin(icell)) = 1   ! flag numbers for basins
      enddo
      
      k=0
      precip=0.0d0
      sum_intrnl=0.0d0
      sum2ocean=0.0d0
      export2ocean = 0.0d0
      sum2ocean_alltime=0.0d0
      sumatocean = 0.0d0
      total_initial_water = 0.0d0
      globe_cloud=0.0d0             ! setting the global cloud water content
      totjunk = 0.0d0

c  Read Utqiagvik meteorology data. Also surface C estimates (g C m-2)
      open(70,file='data_meteorology_Utqiagvik.txt')
      open(71,file='data_surfaceC_1980_2020.txt')
      do iyr = 1980, 2020
         idoy = 0
         do imon = 1, 12
            call days4month(iyr,imon,ndays)
            do iday = 1, ndays
               idoy = idoy + 1
               read(70,'(i4,2i5,f8.2,f8.1,16x,f8.2)') 
     $              iyear, imonth, i_day, tair, precip, windsp
               if (iyear .ne. iyr .or. imonth .ne. imon .or.
     $                 i_day .ne. iday) stop 'site data read error'          
               sitetair(iyr,idoy) = tair
               siteprcp(iyr,idoy) = precip
               sitewind(iyr,idoy) = windsp
            enddo
         enddo
         read(71,'(4x,f8.4)') surfaceC(iyr)
      enddo   
     
c  Initialize arrays and fill array with rootdepth and maxthawdepth from file
c  Read in initial soil and ground water storage, snowpack, and snow water.
c  Also read soil texture from file and call lookup.f to get soil porosity,
c  fieldcapacity, and wilting point. 
      print*,'*****************************************************'
      open(49,file=elevfile)
      open(50,file=rootfile)
      open(51,file=temvegfile)
      open(52,file=spinupfile)
      read(52,*)                ! read header
      open(53,file=soiltextfile) ! soil textures at gridcells
      open(55,file=watbodyfile)
      open(56,file=freshsnowfile)
      open(57,file=snowclassfile)
      open(58,file=peatfracfile)
      open(60,file=carbondensityfile1)     ! carbon density 0-100 cm 
c      open(61,file=carbondensityfile2)     ! carbon density 100-200 cm 
c      open(62,file=carbondensityfile3) ! carbon density 200-300 cm

      do icell = 1, ncells
         read(49,*) elev(icell)
         read(50,*) rootdepth_input  
         read(51,*) iveg1(icell)
         read(53,*) isoilclass

c  extentLakemin(icell) is the minimum wetland. This is the
c semi-permanent open water extent.
         read(55,*) extentMin(icell)
         fracLand(icell) = 1.0d0 - extentMin(icell)
         read(56,*) soil_frsnow(icell)
         read(57,*) isnowclass(icell)
         read(58,'(23f6.2)') (peatfraction(i),i=1,lx)
         read(60,*) carbondensity(1,icell)
         carbondensity(1,icell) = 50.0d0
         carbondensity(2,icell) = carbondensity(1,icell)
         carbondensity(3,icell) = carbondensity(1,icell)
c     read(61,*) r_lat, r_lon, carbondensity(2,icell)
c         read(62,*) r_lat, r_lon, carbondensity(3,icell)

c  These lines and ones below near line 800 can be used to run model
c   over just one grid cell or over Alaska region. By uncommenting next line 
c   the model sums water over just those cells in order to calculate water
c   balance checks.
         if (ONECELL_SWITCH .and. icell .ne. igetcell) cycle ! Run one grid
         jvalidGrid(icell) = 1

c  Read new spinup information with multi-layer soil water and ice profiles
         if (noyes_spinup .eq. 0) then ! read just rough ice and soil temps
            read(52,*) irec, imon, iday, watbodystore, snowtoday,
     $           snowwattoday, riverwat, (icetoday(i),i=0,lx),
     $           (soil_temperature(icell,i),i=sx,lx+1)
         else if (noyes_spinup .eq. 1) then  ! read previous detailed spinup
            read(52,*) irec, imon, iday, watbodystore, snowtoday,
     $           snowwattoday, riverwat, (watertoday(i),i=0,lx),
     $      (icetoday(i),i=0,lx),(soil_temperature(icell,i),i=sx,lx+1),
     $      (soil_saturation0(icell,i),i=sx,lx+1)
                soil_saturation1=soil_saturation0
         else
            print*, 'Spinup Yes/No code not 0 or 1'
            stop
         endif    

c  Look up soil characteristics for given soil class.  Convert units for soil 
c  variables.  Also set some array values.
         call lookup_v3(isoilclass,lx,peatfraction,soilporosity,
     $     fieldcapacity,wiltingpoint,bulkdensity,thermconddry,
     $     heatcapdry,sfreezing_pd,scleaness,porositycombined,
     $     fcapacitycombined,hk_sat,psi_sat,beta_combined)


!  Set the soil porosity array by soil layer and grid cell. Porosity has units
!  cm3/cm3. Field capacity also has units of cm3/cm3(ie. percent volume)
         do i = 1, lx
            peatfractionarray(i,icell) = peatfraction(i)
            if (isoilclass .eq. 1) then
               peatfractionarray(i,icell) = 
     $           min(peatfraction(i)*1.1d0,1.0d0)
            endif
            porosityarray(i,icell) = porositycombined(i)
            fcapacityarray(i,icell) = fcapacitycombined(i)
            hksatcombined(i,icell) = hk_sat(i)
            psisatcombined(i,icell) = psi_sat(i)
            betacombined(i,icell) = beta_combined(i)
         enddo   

         soil_freezing_pd(icell,:)=sfreezing_pd
         soil_cleaness(icell,:)=scleaness
         soil_snowthcnd(icell)=0.0d0
         soil_snowheight(icell)=0.0d0

c  Next two do loop blocks set values for lake and wetland grids. 
         snowtoday = 0.0d0      ! zero out
         snowwattoday = 0.0d0   ! zero out
         watbodystore = 100.0d0 
         do i = 0, lx
            watertoday(i) = 0.0d0     
            icetoday(i) = 0.0d0       
            ajunk(i) = 0.0d0
         enddo

c         endif

         root_depth_physical(icell) = rootdepth_input
         root_porosity(icell) = rootdepth_input * soilporosity
         wilt_point(icell) = wiltingpoint / soilporosity
         wilt_point_percent(icell) = wiltingpoint
         bulk_dens(icell) = bulkdensity
         therm_conddry(icell) = thermconddry  ! save to array by grid cell
         heat_capdry(icell) = heatcapdry

c  Place each initial value in a spatial array.          
         wsnow(icell)=snowwattoday
         snowpack(icell)=snowtoday
         snowage(icell) = 0.0
         watbodywat(icell) = watbodystore      
         riverwater(icell) = riverwater_initial


c  Set soil temperature and moisture array values for upland grids.
c  This block does not execute for lake or wetland grids.
c         if (iveg1(icell,1) .ne. 10 .and. iwatbody(icell) .ne. 1)then
         call compute_dzmm(soilnode*1.0d3, lx, dzmm)
         water4layer(sx:0,icell) = 0.0d0  ! zero for the 'above surface' layer
         ice4layer(sx:0,icell) = 0.0d0 ! zero for the 'above surface' layer
        if (noyes_spinup .eq. 1)  goto 13101  !full spinup read...skip ahead  
 
         do i=sx,0
            call soilsat(soil_temperature(icell,i),
     &           soil_liqfraction(icell,i),
     &           scleaness,sfreezing_pd)
            soil_saturation0(icell,i) = 0.0d0
            soil_saturation1(icell,i) = 0.0d0
            soil_liqfraction(icell,i) = 1.0d0
         enddo

         do i=2,lx+1
            call soilsat(soil_temperature(icell,i),
     &           soil_liqfraction(icell,i),
     &           scleaness,sfreezing_pd)

            if (soil_liqfraction(icell,i) < CR_LIQ_FRACTION) then
               icetoday(i-1) = porosityarray(i-1,icell)*dzmm(i-1)*1.0d0         
               watertoday(i-1) = 0.0d0
               soil_saturation0(icell,i) = icetoday(i-1)/
     &                (porosityarray(i-1,icell)*dzmm(i-1))
               soil_saturation1(icell,i)=soil_saturation0(icell,i)
            else
               icetoday(i-1)=0.0d0
               watertoday(i-1) =porosityarray(i-1,icell)*dzmm(i-1)*1.0d0
               soil_saturation0(icell,i)=watertoday(i-1)/
     &              (porosityarray(i-1,icell)*dzmm(i-1))
               soil_saturation1(icell,i)=soil_saturation0(icell,i)
            endif
         enddo
        ! next block sets water and ice of bottom layer
         if (soil_liqfraction(icell,lx) < CR_LIQ_FRACTION) then
            icetoday(lx) = porosityarray(lx,icell)*dzmm(lx)*1.0d0 
            watertoday(lx) = 0.0d0
         else
            icetoday(lx)=0.0d0
            watertoday(lx) =porosityarray(lx,icell)*dzmm(lx)*1.0d0 
         endif      
13101    continue

c    soilwatNEW and soiliceNEW are total over entire soil layer, indexes 1-lx 
c  For a lake or wetland, variable water4layer(i) was set to zero above
         soilwatNEW = 0.0d0   ! initialize to zero
         soiliceNEW = 0.0d0   ! initialize to zero
         upper_soilwat = 0.0d0
         upper_soilice = 0.0d0

         soilDOC4layer(0,icell) = 1.0d0    ! initial condition, surface pool
         
         do i = 1, lx
            if (watertoday(i) .lt. 0.0d0) stop 'layer water < 0'
            if (icetoday(i) .lt. 0.0d0) stop 'layer ice < 0'
            water4layer(i,icell) = watertoday(i)    ! as input from spinup
            ice4layer(i,icell) = icetoday(i)        ! as input from spinup
            if (water4layer(i,icell) .lt. 0.0d0 .or. ice4layer(i,icell)
     $                .lt. 0.0d0) then
               print*, icell, i, water4layer(i,icell),ice4layer(i,icell)
               stop 'Water < 0 on input'
            endif

            soilDOC4layer(i,icell) = 1.0d0   ! initial condition
            
c  Make sure water+ice of layer does not exceed capacity of layer.
            varjunk = dzmm(i) * porositycombined(i) ! junkvar for testing
            if (water4layer(i,icell)+ice4layer(i,icell).gt.varjunk) then
               if (soil_liqfraction(icell,i) < CR_LIQ_FRACTION) then
                  ice4layer(i,icell) = varjunk * 1.0d0
                  water4layer(i,icell) = 0.0d0
               else
                  ice4layer(i,icell) = 0.0d0
                  water4layer(i,icell) = varjunk * 1.0d0
               endif
            endif
  
            soilwatNEW = soilwatNEW + water4layer(i,icell)
            soiliceNEW = soiliceNEW + ice4layer(i,icell)

      enddo

c   This block sets initial input land water from water state variables. 
         total_initial_water = total_initial_water +
     $   ( (snowtoday + snowwattoday + soilwatNEW +soiliceNEW) 
     $       * km2mm*area + riverwater_initial ) * fracLand(icell)
         total_initial_water = total_initial_water + 
     $        watbodystore * (1.0 - fracLand(icell)) * km2mm*area

      enddo

 444  total_initial_water = total_initial_water + globe_cloud

c  Start outmost loop for spinup.  
c  Inner loop processes water balance at gridcells.

      ntotdays=0
c     *************************************************************************
c     *************** start spin-up loop **************************************
c     *************************************************************************
      do init = 1, nspinup+1   
                               
      rmissing = -9999.00d0    ! missing value code for input data
      rmissing2 = -999.9d0    ! missing value code for select outputs

      if (init .lt. nspinup+1) nyear = 1
      if (init .eq. nspinup+1) then
           nyear = ilstyr - ifrstyr + 1
           print*, '************  Beginning transient run  ***********'
           print*, ' '
      endif

      do k = 1, nyear   
          
      iyr = ifrstyr + k - 1
      
      numdays =  365
      if (mod(iyr, 4) .eq. 0 .and. mod(iyr, 100) .ne. 0) 
     $        numdays = 366
      if (mod(iyr, 400) .eq. 0) numdays = 366
      if (numdays .eq. 366) then 
          monlastday(2) = 29
      else
         monlastday(2) = 28
      endif  
         
      if (init .eq. nspinup + 1) then
cc     write(fname3, '(''waterstorage2.'',i4)') iyr
cc         open(82, file=outpath(1:lengthout)//fname3)
         write(fname3, '(''soilT.'',i4)') iyr
c         write(fname3, '(''soilMoist.'',i4)') iyr
         open(98,file=outpath(1:lengthout)//fname3)
      endif

c  Call subroutine to read data from files.  A two-dimensional array
c  (time,gridcell index) is returned.
c  Subroutine inputs are:
c     pname(k) - path/filename (39 characters) for input data
c     rmissing - missing value code (real).  Values are screened in subr.
c     iyr      - the year index, used to determine the number of days
c  Outputs are:
c     evap, prcp, temp - (numdays, ncells) for each day at every grid cell.

      if (init .eq. 1 .or. init .eq. nspinup+1) then

c             print*, 'Reading precipitation data file '
c             call read_data_ann(prcppath, rmissing, iyr, prcp)

c             print*, 'Reading temperature data file '
c             call read_data_ann(temppath, rmissing, iyr, temp)

c             print*, 'Reading wind speed data file '
c             call read_data_ann(windpath, rmissing, iyr, windvals)
             
             if (read_evapdat) then
                print*, 'Reading evaporation data file '
                call read_data_ann(radpath, rmissing, iyr, evap)
             endif

             if(ievapfunc .eq. 2) then
                print*, 'Reading data files to calculate Penman PET'
                call read_data_ann(tmaxpath, rmissing, iyr, tmaxvals)
                call read_data_ann(tminpath, rmissing, iyr, tminvals)
                call read_data_ann(vaporpath, rmissing, iyr,vaporvals)
                call read_data_ann(radpath, rmissing, iyr, radvals)
             endif

             if(ievapfunc .eq. 1 .and. read4energy .eqv. .true.) then
                print*, 'Reading vapor pressure, wind, and radiation '
                call read_data_ann(vaporpath, rmissing, iyr,vaporvals)
                call read_data_ann(radpath, rmissing, iyr, radvals)
             endif

             length = index(laipath, ' ') - 1 
             lainame = laipath(1:length)
             call read_LAI(lainame, iyr, ncells, laivals)   
             
         endif 

         do idoy=1, numdays  ! idoy: date of the year, same as julday

         ntotdays = ntotdays + 1 ! a count of total days for model run.
                                    ! it's reset for each spinup loop (if any)                              
         do m=0, ncells       
            river_upstream_prev(m) = 0.0d0
         enddo

         julday = idoy  ! set julian day of year

         call get_date(iyr, idoy, imon, iday)

         sum_wsnow = 0.0d0
         sum_snowpk = 0.0d0
         sum_p = 0.0d0
         sum_et= 0.0d0
         sum_TWS = 0.0d0
         sum_water4Land = 0.0d0
         sum_soilwaterice = 0.0d0    
         sum_watbodystore = 0.0d0
         sum_runoff = 0.0d0
         sum_riverwater = 0.0d0
         sum_snowsubl = 0.0d0   
         sum_surfevap = 0.0d0

c   Zero out the monthly runoff accumulation for each of the basins in domain
c   Also zero out variable accumulations for other parameters. These are not
c   currently being summed for all the individual basins
        if( iday .eq. 1) then
             do i=1, nbasins
               do j=1, navs
                  sumbas(j,i) = 0.0d0
               enddo
             enddo  
        endif

c    ****************************************************************************
c    *************************   Start gridcell loop  ***************************
c    ****************  Begin water balance calculations by gridcell**************
c    **************************************************************************** 
         mcell = 0 
         do icell = 1, ncells 
            if (idoy == 1) jsurfwatcount(icell) = 0  ! ann counter surf RO.
            if (iday .eq. 1) then  
               evap1(icell,1:31) = -9999.0d0
               runoff1(icell,1:31) = -9999.0d0
               baseflow1(icell,1:31) = -9999.0d0
               snowwateq1(icell,1:31) = -9999.0d0
               snowice(icell,1:31) = -9999.0d0
               snowwater(icell,1:31) = -9999.0d0
               snowmelt1(icell,1:31) = -9999.0d0
               DOC_stream(icell,1:31) = -9999.0d0
               baseflowDOC1(icell,1:31) = -9999.0d0
            endif  

            if (ONECELL_SWITCH .and. icell .ne. igetcell) cycle !Run one cell

            mcell = mcell + 1

c  Read calibration parameters for sublimation and ET hydrology.            
            if (ibasin(icell) .eq. 10) then
	       param1 = param1b
               param2 = param2b
               param3 = param3b
               param4 = param4b
               param5 = param5b
            else
               param1 = param1a
               param2 = param2a
               param3 = param3a
               param4 = param4a
               param5 = param5a
            endif
 
            soilwatNEW = 0.0d0  ! summation for grid/day, initialize to zero
            soiliceNEW = 0.0d0  ! summation for grid/day, initialize to zero

            if (init .eq. 1 .and. idoy .eq. 1) then
               soil_snowdensity(icell) = 100.0d0   ! intialize soft snow density

               if (icell .eq. igetcell) then
                  sumprecip = 0.0d0  ! the following for testing annual totals
                  sumpet = 0.0d0         
                  sumsnow = 0.0d0
                  sumsubl = 0.0d0
                  sumsurfevap = 0.0d0
                  sumavailwat = 0.0d0
                  sumrunoff = 0.0d0
                  sumriver = 0.0d0
               endif
   
            endif

c  ************  Initialize monthly runoff to zero and open output file  *********
            if (idoy .eq. 1) then
               do imth=1, 12
                  monthrunoff(icell,imth) = 0.0d0
                  monthbaseflow(icell,imth) = 0.0d0
                  monthprcp(icell,imth) = 0.0d0
                  monthevap(icell,imth) = 0.0d0
                  monthsub(icell,imth) = 0.0d0
                  monthswe(icell,imth) = 0.0d0
                  monthmeltwat(icell,imth) = 0.0d0
                  monthsnowdepth(icell,imth) = 0.0d0
                  monthsoilval(icell,imth) = 0.0d0
               enddo
            endif   

c  Set scaler precip, tair, et, ALT from arrays. Read tseries data to get PET.  
c  Also scale precip if so desired for the run.
c  yyh: note that here I changed "iday" to julian day...

c          precip = prcp(idoy,icell) !put prcp(time,gridcell) into scaler var.

c          windsp = windvals(idoy,icell)
c          if (temp(idoy,icell) .gt. 150.0d0) then
c            tair = temp(idoy,icell) - 273.16d0 ! set "tair" from array
c          else   
c            tair = temp(idoy,icell)
c          endif            
            precip = siteprcp(iyr,idoy)
            tair = sitetair(iyr,idoy)
            windsp = sitewind(iyr,idoy)

            if (precip .lt. 0.0d0) precip = 0.0d0

c            tmin = tminvals(idoy,icell) - 273.16d0
c            tmax = tmaxvals(idoy,icell) - 273.16d0
c            vaporpress = vaporvals(idoy,icell) * 0.1d0

c            radnet = radvals(idoy,icell)

c  Set last day of month.  Also used as number of days in month     

            if (iday.eq.1.and.mcell.eq.1) then
               lastday = monlastday(imon)
            endif   

            ivegcov = iveg1(icell)
            if (ivegcov .eq. 0) then
               print*, icell, imon, iday
               stop 'Veg = 0'
            endif
            rLAI = laivals(imon,iday,icell) 

c  ***********************   Get Potential ET   ****************************
            if(read_evapdat) then
                potent_et = evap(idoy,icell) 
            else
               if(ievapfunc.eq.1) 
     $              call hamon(rlat(icell),julday,tair,potent_et) 
               if(ievapfunc.eq.2) then
                  if (ivegcov .gt. 8) ivegcov = 8
                  FL = 0.5d0 ; sheat = 0.0d0 
                  sngl_lat=rlat(icell) ; sngl_lon=rlon(icell)
                  sngl_lai = sngl(rLAI) ; sngl_sheat=sngl(sheat)
                  sngl_snow=sngl(snowprev+snowwatprev) ;sngl_FL=sngl(FL)
                  sngl_wind=sngl(windsp) ; sngl_rad=sngl(radnet)
                  sngl_vap=sngl(vaporpress)
                  sngl_tmax=sngl(tmax) ; sngl_tmin=sngl(tmin)
                  sngl_tair = (sngl_tmax + sngl_tmin) / 2.
                  
                  iflag = 0

                  potent_et = dble(pmdayf(julday,sngl_lat,sngl_lon, 
     $            ivegcov,sngl_lai,sngl_snow,sngl_FL,sngl_wind,sngl_rad,
     $            sngl_tair,sngl_vap,sngl_sheat,sngl_tmax,
     $                      sngl_tmin,iflag))
               endif   
            endif
            
            if (potent_et .lt. 0.0d0) potent_et = 0.0d0
            potent_et = potent_et * 0.75d0   

            snowwatprev=wsnow(icell)
            snowprev=snowpack(icell)
            snow_age_prev = snowage(icell)
            watbodywatprev=watbodywat(icell)
            watbodysnowprev=watbodysnow(icell)
            riverwatprev = riverwater(icell)
            riverVolumeprev(icell) = riverVolume(icell)  

c  Set values for soil layers from previous day, or from the 
c  spinup input brought in above section. Do also for surface water pool.
            soilwatprevNEW = 0.0d0
            soiliceprevNEW = 0.0d0
            soilwatNEW = 0.0d0  
            soiliceNEW = 0.0d0  
            upper_soilwat = 0.0d0
            upper_soilice = 0.0d0
            runoff = 0.0d0     
            do i = 0, lx    ! index 0 is for the surface pool
               water4layerprev(i) = water4layer(i,icell)
               ice4layerprev(i) = ice4layer(i,icell)
               soilDOC(i) = soilDOC4layer(i,icell)
            enddo

            rad_melt = 0.0d0    ! not used in this version

            if (tair .lt. tsnow_cutoff) then
               psnow = precip
               prain=0.0d0
            else
               prain = precip
               psnow = 0.0d0
            endif

c     Call snow subroutine  
            call snow(snowprev,snowwatprev,snowretain,snowrelease,
     $           rad_melt,tair,tsnow_cutoff,precip,potent_et,ivegcov,
     $           rLAI,snowtoday,snowwattoday,avail_wat,param1,param2,
     $            snowmelt,snow_subl,iwrite)
            surf_evap = 0.0d0
            snowpack(icell)=snowtoday
            wsnow(icell)=snowwattoday

            printflag = .false.  !  .true. .false.            
            
c  Set rooting depth (physical depth) from array 
 250        rootdepthphysical = root_depth_physical(icell)
            if (rootdepthphysical .eq. 0.0d0) 
     $                   rootdepthphysical = 100.0d0

c  Call soil subroutine to move water into and through soil, handle 
c  evapotranspiration, and runoff. First zero out variables updated each day. 
            soilwatNEW = 0.0d0
            soiliceNEW = 0.0d0
            upper_soilwat = 0.0d0
            upper_soilice = 0.0d0
            soilwatprevNEW = 0.0d0
            soiliceprevNEW = 0.0d0
            evap4surfacepool = 0.0d0
            surfpoolrunoff = 0.0d0
            evap_lake_watbody = 0.0d0
            watbodyrunoff = 0.0d0
            transpiration = 0.0d0

            do i = 1, lx
c                Both porosity and field capcity are in units of cm3/cm3
               peatfraction(i) = peatfractionarray(i,icell)
               porosity_4layer(i) = porosityarray(i,icell)
               fcapacity_4layer(i) = fcapacityarray(i,icell)
               hk_sat(i) = hksatcombined(i,icell)
               psi_sat(i) = psisatcombined(i,icell)
               beta_combined(i) = betacombined(i,icell)
               stemp_4layer(i) = soil_temperature(icell,i)
            enddo

            densityC1 = carbondensity(1,icell)
            densityC2 = carbondensity(2,icell)
            densityC3 = carbondensity(3,icell)

            iwrite = 0

            surface_conduct = surfaceConduct(tair,rLAI,iwrite)

            if (ibasin(icell) .eq. 10) then
               production_k = production_k_sub_mack
               decomp_k = decomp_k_sub_mack
            else if (ibasin(icell) .eq. 23) then   
               production_k = production_k_sub_yukon     ! 0.2d-5
               decomp_k = decomp_k_sub_yukon       ! 0.5d-2
            else
               production_k = production_k_sub_other  ! 1.0d-7
               decomp_k = decomp_k_sub_other     ! 0.5d-1
            endif   

            if (imon .le. 4 .or. imon .ge. 11) then
               iWinterFlag = 1
            else
               iWinterFlag = 0
            endif   
            call soilzone(icell,ntotdays,iWinterFlag,
     $           rootdepthphysical,iwatbody(icell),peatfraction,
     $           densityC1,densityC2,densityC3,stemp_4layer,
     $           production_k,decomp_k,ivegcov,       
     $           fcapacity_4layer,hk_sat,psi_sat,beta_combined,
     $           water4layerprev,ice4layerprev,wilt_point(icell),
     $           wilt_point_percent(icell),potent_et,infiltration,
     $           rootbaseflowfact,deepbaseflowfact,tair,avail_wat,
     $           surface_conduct,param3,param4,soilDOC,       
     $           bulk_dens(icell),porosity_4layer,watertoday,
     $           icetoday,baseflow,overlandrunoff,transpiration,
     $           capacity_4layer,DOCsubsurface,ET_SWITCH,
     $           INFILTRATION_SWITCH,iwrite)
            runoff = baseflow + overlandrunoff

c  HERE HANDLE SURFACE POOL.

            if (watertoday(0) .gt. 0.0d0) then
               evap4surfacepool = min(watertoday(0),potent_et)
               watertoday(0) = watertoday(0) - evap4surfacepool
               surfpoolrunoff = watertoday(0) * param5  
               watertoday(0) = watertoday(0) - surfpoolrunoff
               
               if (watertoday(0) .gt. 90.0d0) then 
                  excess = (watertoday(0) - 90.0d0) * param5
                  surfpoolrunoff = surfpoolrunoff + excess
                  watertoday(0) = watertoday(0) - excess
               endif 
            endif
            runoff = runoff + surfpoolrunoff
               
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Approximate C leached from any surface runoff....  Updated Jan 2020
               
            if (ibasin(icell) .eq. 10) then
               production_k = production_k_surf_mack     
               decomp_k = decomp_k_surf_mack
            else if (ibasin(icell) .eq. 23) then   
               production_k = production_k_surf_yukon   
               decomp_k = decomp_k_surf_yukon      
            else
               production_k = production_k_surf_other     
               decomp_k = decomp_k_surf_other        
            endif

            jsnowwatflag = 0    ! initialize to zero
            if (imon == 4 .or. imon == 5 .or. imon == 6) then
               jspringflag = 1
            else
               jspringflag = 0
            endif   
            if (surfpoolrunoff .gt. 0.0d0 .or. snowwattoday .gt. 0.0d0
     $           .or. snowmelt .gt. 0.0d0) then
               if ((snowwattoday > 0.0d0 .or. snowmelt > 0.0d0) .and.
     $                imon >= 4 .and. imon <= 6)
     $              jsnowwatflag = 1

               if (surfpoolrunoff > 0.0d0 .and. imon >= 4 .and. imon
     $           <= 6) jsurfwatcount(icell) = jsurfwatcount(icell) + 1 
               densitysurfC = surfaceC(iyr)   ! newer surface C estimates
               call doc4surface(stemp_4layer,soilDOC,jsnowwatflag,
     $    jspringflag,jsurfwatcount(icell),watertoday(0),surfpoolrunoff,
     $          densitysurfC,production_k,decomp_k,DOCsurface,iwrite)

            else
               DOCsurface = -999.9d0
            endif

            call mergeDOC(surfpoolrunoff,DOCsurface,baseflow,
     $           DOCsubsurface,DOC4day)
            if (DOC4day > 0.0d0) then
               DOC_stream(icell,iday) = DOC4day*1000.0d0 ! in mg C m-2
            else
               DOC_stream(icell,iday) = -999.9
            endif   

 126        format(3i4,7f8.3,13f10.4)
            iwrite = 0
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

            do i = 0, lx
               water4layer(i,icell) = watertoday(i)
               ice4layer(i,icell) = icetoday(i)
               soilwatprevNEW = soilwatprevNEW + water4layerprev(i)
               soiliceprevNEW = soiliceprevNEW + ice4layerprev(i)
               soilwatNEW = soilwatNEW + water4layer(i,icell)
               soiliceNEW = soiliceNEW + ice4layer(i,icell)
               
               watertoday(i) = 0.0d0    
               icetoday(i) = 0.0d0
               soilDOC4layer(i,icell) = soilDOC(i)
            enddo
            do i = 0, 12
               upper_soilwat = upper_soilwat + water4layer(i,icell)
               upper_soilice = upper_soilice + ice4layer(i,icell)
            enddo   
               
c   This routine gets conductivity using combined liquid and solid water 
c   amounts. 
      call conductivity_v3(lx,peatfraction,porosity_4layer,
     $therm_conddry(icell),therm_condpeatdry,KA,dry_soil_thcnd(icell,:),
     $ heat_capdry(icell),hcapacitypeatdry,CA,dry_soil_heatc(icell,:),
     $ iwrite)

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c            goto 13120       ! bypass permafrost code

      if (psnow .gt. 0.0d0) then
         snow_water_change = snow_water_change + psnow
      else   
         snow_water_change = 0.0d0
      endif   
      SNOW_TIMESTEP = 86400.0d0

      ro_soft_snow_old = soil_snowdensity(icell)
      if (snowprev .le. 1.0d0) ro_soft_snow_old = 0.0d0  
      if (soil_snowheight(icell) == 0.0d0) snow_age = 0.0d0

      if (snowtoday+snowwattoday .gt. 0.0d0) then
         call snowdepthDensity(isnowclass,soil_snowheight(icell),
     $      mlayers,depth4layer,
     $    thickness4depth,depth4interface,frac_bottom)
          call surface_snow_1(tair,windsp,precip,ro_soft_snow_old,
     $      Utau_t,ro_soft_snow,snowThermCondUp,SNOW_HEATC)

         snowThermCondUp = 1.38D-1 - (1.01D0 * (ro_soft_snow/1.0D3)) + 
     $        (3.233D0 * ((ro_soft_snow/1.0D3) ** 2.0D0) ) 
         if (isnowclass(icell) == 1) then
            snowThermCondBot = 0.18d0 
            rho_depthhoar = 360.0d0  
            SNOW_THCND = snowThermCondBot * frac_bottom + 
     $                       snowThermCondUp * (1.0d0 - frac_bottom)
         else if (isnowclass(icell) == 2) then
            snowThermCondBot = 0.072d0 
            rho_depthhoar = 230.0d0
            SNOW_THCND = snowThermCondBot * frac_bottom + 
     $                       snowThermCondUp * (1.0d0 - frac_bottom)
         else  
            snowThermCondBot = 0.167d0
            rho_depthhoar = 330.0d0
            SNOW_THCND = snowThermCondBot * frac_bottom + 
     $                       snowThermCondUp * (1.0d0 - frac_bottom)
         endif   

         SNOW_THCND = max(SNOW_THCND,0.03d0)  ! set a floor for conductivity

         if (psnow .gt. 0.0d0) then
            depth_newsnow = (psnow * 1.0d-3) * 
     $        (1000. / ro_soft_snow)
            if (soil_snowheight(icell) .gt. 0.0d0) then  
               frac_new = 
     $         min(1.0d0,depth_newsnow/soil_snowheight(icell)) 
            else
               frac_new = 1.0d0    
            endif   
            if (frac_new .le. 0.0d0 .or. frac_new.gt.1.0d0) then
               print*, depth_newsnow, soil_snowheight(icell),
     $                 frac_new
               stop 'Error'
            endif   
            if (ro_soft_snow_old .gt. 0.0d0) then
               ro_snow_grid = ro_soft_snow * frac_new +
     $              ro_soft_snow_old * (1.0d0 - frac_new)
            else
               ro_snow_grid = ro_soft_snow
            endif   
         else   
           ro_snow_grid = ro_soft_snow
         endif  

c  Increment day for snow age. It is reset to zero above if there is no snow
         snow_age = snow_age_prev + 1.0d0

         soil_snowdensity(icell) = ro_snow_grid 
         soil_snowthcnd(icell) = SNOW_THCND
         soil_snowheatc(icell) = SNOW_HEATC

         if (soil_snowdensity(icell) .le. 0.0d0) then
            print*, snowtoday, ro_soft_snow
            stop 'snow density = 0'
         endif   
         soil_snowheight(icell) = ((snowtoday+snowwattoday)*1.0d-3) * 
     $        (1000. / soil_snowdensity(icell))  ! snow depth in meters

      else
         snow_age = 0.           
         soil_snowheight(icell) = 0.  
      endif
      snowage(icell) = snow_age

      do i=2,lx+1
         if(soil_liqfraction(icell,i)<CR_LIQ_FRACTION) then
            SS0=ice4layer(i-1,icell)/capacity_4layer(i-1) 
            SS1=SS0

            if(soil_liqfraction(icell,i)<CR_LIQ_FRACTION*0.95d0) then
               max_dw=0.00d0*(1.0d0-SS0)
     &              *peatfractionarray(i-1,icell)*capacity_4layer(i-1)
               rel_dw=min(max_dw,water4layer(0,icell)) 
               water4layer(0,icell)=water4layer(0,icell)-rel_dw
               ice4layer(i-1,icell)=ice4layer(i-1,icell)+rel_dw
               SS1=ice4layer(i-1,icell)/capacity_4layer(i-1)
            endif

            soil_saturation0(icell,i)=SS0
            soil_saturation1(icell,i)=SS1

        else
            soil_saturation0(icell,i)=water4layer(i-1,icell)/
     &            capacity_4layer(i-1) 
            soil_saturation1(icell,i)=soil_saturation0(icell,i)
        endif
      enddo
 
        call update_properties(soil_x(icell,:),soil_sn(icell), 
     &       soil_snowheight(icell),
     &       soil_snowthcnd(icell), soil_snowheatc(icell),
     &       porosityarray(:,icell),
     &       dry_soil_thcnd(icell,:),dry_soil_heatc(icell,:),
     &       soil_liqfraction(icell,:),
     &       soil_saturation0(icell,:),
     &       soil_saturation1(icell,:),
     &       soil_freezing_pd(icell,:),soil_cleaness(icell,:))

        soil_time(icell)=soil_time(icell)+1.0D0 

        SURFACE_TEMPERATURE_BEGIN= 
     &           soil_temperature(icell,soil_sn(icell))
        SURFACE_TEMPERATURE_END  = tair         

        soil_liqfraction_prev(icell,:)=soil_liqfraction(icell,:)
        call stemperature(soil_temperature(icell,:),
     &                  soil_liqfraction(icell,:),
     &                  soil_timestep(icell),
     &                  soil_sn(icell),soil_gc(icell))

         if(julday .eq. numdays) then
             if(maxval(soil_phchange(icell,:)).eq.1) then
              i=2
              do while (I.LE.LX)
                 if(soil_phchange(icell,i).eq.1) then
                    i=i+1
                 else
                    isoil_ALD(icell)=i-1
                    i=i+lx
                 endif
              enddo

              i=isoil_ALD(icell)
              if(soil_frozen(icell).eq.1) then 
                 soil_ALD(icell)=(XREF(I-1)+XREF(I))*0.5D0
              else             
                 soil_ALD(icell)=-(XREF(I-1)+XREF(I))*0.5D0
              endif             
           else
              isoil_ALD(icell)=-1
              soil_ALD(icell)=-999.9d0
           endif
           soil_ALD_T(icell)=soil_ALD_tmp(icell)
           
           soil_ALD_tmp(icell)=0.0d0
           soil_frozen(icell)=0
           soil_phchange(icell,:)=0
        endif

        if(isoil_ALD(icell)>0) then
           soil_ALD_tmp(icell)=soil_ALD_tmp(icell)
     &          +soil_temperature(icell,isoil_ALD(icell)+1)/365.0d0
        else
           soil_ALD_T(icell)=-999.9d0
        endif

      do i=2,lx+1
           if((soil_liqfraction_prev(icell,i)-CR_LIQ_FRACTION)*
     &      (soil_liqfraction(icell,i)-CR_LIQ_FRACTION)<0.0d0) then
              soil_phchange(icell,i)=1
           endif
      enddo

        call check_soilfrozen(soil_liqfraction(icell,:),i)
        soil_frozen(icell)=max(soil_frozen(icell),i)

      do i=2,lx+1
         if((soil_liqfraction(icell,i) < CR_LIQ_FRACTION).and. 
     &      (water4layer(i-1,icell) > 0.0d0) ) then
            ice4layer(i-1,icell) = water4layer(i-1,icell)
            water4layer(i-1,icell)=0.0d0  
         endif
         if((soil_liqfraction(icell,i) > CR_LIQ_FRACTION).and. 
     &      (ice4layer(i-1,icell) > 0.0d0) ) then
            water4layer(i-1,icell) = ice4layer(i-1,icell)
            ice4layer(i-1,icell)=0.0d0
          endif
       enddo

 13120 continue


      check = (avail_wat+soilwatprevNEW+soiliceprevNEW) - 
     $    (soilwatNEW+soiliceNEW+
     $     runoff+transpiration+evap4surfacepool)
      if (abs(check) .gt. 1.0d-6) then
         write(*,*)' '
         write(*,*)'Balance check failed after soil routine'
         write(*,'(a,f14.10)') 'Check = ', check
         write(*,*)' '
         write(*,'(3i6,13f14.6)') imon,iday,icell,avail_wat,
     $        soilwatprevNEW,soiliceprevNEW,
     $    soilwatNEW,soiliceNEW,runoff,transpiration,
     $        evap4surfacepool
         stop
      endif
 30   format(i5,10f10.2)

c  Next block handles water balance for lake/wetland portion of the grid. 
         call waterzone(tair,prain,psnow,snowmelt,watbodywatprev,
     $    watbodysnowprev,potent_et,watbody_wat,
     $     watbody_snow,extentMin(icell),extentMax(icell),
     $       watbodyrunoff,evap_lake_watbody,iwrite)
         watbodystore = watbody_wat + watbody_snow
         watbodywat(icell) = watbody_wat
         watbodysnow(icell) = watbody_snow

      check = (precip + watbodywatprev + watbodysnowprev) - 
     $       (watbodystore + watbodyrunoff + evap_lake_watbody)

      if (abs(check) .gt. 1.0d-6) then
         write(*,*)' '
         write(*,*)'Balance check failed after wetland subroutine'
         write(*,'(a,f14.10)') 'Check = ', check
         write(*,*)' '
         write(*,'(3i6,6f14.6)') imon,iday,icell,precip,
     $  watbodywatprev,watbodysnowprev,watbodystore,watbodyrunoff,
     $        evap_lake_watbody
         stop
      endif

c  Here mosiac all of the runoff and ET contributions across grids 
      runoff_merged = (runoff * fracLand(icell)) + 
     $              (watbodyrunoff*(1.0d0-fracLand(icell)))
      evap_merged = (snow_subl + surf_evap + transpiration + 
     $       evap4surfacepool) * fracLand(icell) + 
     $             (evap_lake_watbody * (1.0d0-fracLand(icell)))

c  Add today's values into monthly summation arrays for output.
      monthprcp(icell,imon) = monthprcp(icell,imon) + precip
      monthsub(icell,imon) = monthsub(icell,imon) + 
     $     snow_subl
      
      monthevap(icell,imon) = monthevap(icell,imon) + (snow_subl +
     $     surf_evap + transpiration + evap4surfacepool)
      
      monthrunoff(icell,imon) = monthrunoff(icell,imon) + runoff

      monthbaseflow(icell,imon) = monthbaseflow(icell,imon) + baseflow 
      
      monthswe(icell,imon) = monthswe(icell,imon) + snowtoday +
     $     snowwattoday
      monthmeltwat(icell,imon) = monthmeltwat(icell,imon)+snowmelt
      monthsnowdepth(icell,imon) = monthsnowdepth(icell,imon) +
     $     soil_snowheight(icell)*100.

      rsum = 0.0d0
      jj = 0
      do i = 1, 7
         if(soil_liqfraction(icell,i+1)>CR_LIQ_FRACTION) then
            rsum = rsum + (water4layer(i,icell)/capacity_4layer(i))
            jj = jj + 1
         else
            rsum = rsum + ice4layer(i,icell)/capacity_4layer(i)
            jj = jj + 1
         endif        
      enddo   

      monthsoilval(icell,imon)=monthsoilval(icell,imon) + watbodystore

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc      

      runoff1(icell,iday) = runoff      ! runoff from just land part of grid
      baseflow1(icell,iday) = baseflow
      evap1(icell,iday) = evap_merged 
      snowwateq1(icell,iday) = snowtoday + snowwattoday  
      snowice(icell,iday) = snowtoday
      snowwater(icell,iday) = snowwattoday
      snowmelt1(icell,iday) = snowmelt
      if (DOCsubsurface .gt. 0.0d0) then
         baseflowDOC1(icell,iday) = DOCsubsurface * 1.0d3  ! converting g to mg
      else
         baseflowDOC1(icell,iday) = -999.9d0
      endif
      if (nspinup .gt. 0 .and.  init .eq. nspinup+1 .and.
     $          iyr .eq. ifrstyr .and. julday .eq. numdays) then 
               if (icell .eq. 1) write(99,'(a100)') '"ID" "Month" "Day" 
     $ "wetland"   "snow"   "snowwater"   "riverwater"   "soilwat(0-23)"
     $ "soilice(0-23)"'

c     cccccccccc      Write file at the end of spinup        ccccccccccccccc
c  Next few line write out grid cell wetlandstorage, snow(solid), snow(liquid),
c   river water, and then the profile for soil water and ice over layer from
c   the above-surface layer (index 0) through the 23 soil layers. 
               write(99,35) icell, imon, iday, watbodystore, snowtoday,
     $          snowwattoday, riverwat, (water4layer(i,icell),i=0,lx),
     $          (ice4layer(i,icell),i=0,lx),
     $          (soil_temperature(icell,i),i=sx,lx+1),
     &          (soil_saturation1(icell,i),i=sx,lx+1)
 35         format(i5,2i3,4f16.8,48f16.8,60f10.4)

         endif

!  Write soil temperatures in summer in order to calculate active layer ALT
         if (init .eq. nspinup+1) then
c            if (init .eq. nspinup+1 .and. 
c     $           julday .ge.205.and.julday.le.260) then 
            write(98,'(i5,i6,23f8.2)') julday, icell, ! 0 to 4.75m
     $           (soil_temperature(icell,i),i=1,15)
c            write(98,'(i5,i6,8f8.4)') julday, icell, ! 0 to 4.75m
c     $           (LAYER_W1(i),i=2,9)
         endif   

!  Here make all runoff scale into river water. This is for balance over
!   all grids with no routine. 
         runoff_volume = runoff_merged * (km2mm * area)
         runoff4routing(icell) = runoff_merged
         riverwater(icell) = riverwatprev + runoff_volume

         sumbas(1,ibasin(icell)) = sumbas(1,ibasin(icell)) + 
     $        precip * km2mm * area
         sumbas(2,ibasin(icell)) = sumbas(2,ibasin(icell)) + 
     $        evap_merged * km2mm *area
         sumbas(3,ibasin(icell)) = sumbas(3,ibasin(icell)) + 
     $        runoff_merged * km2mm * area

c  Next lines do water storage variables
            if (iday .eq. lastday) then     
c  Write storage
c        write(84,'(i5,f10.1)') icell, 
c     $       (snowtoday+snowwattoday+rootwat+rootice+deepwat+deepice)

               sumbas(5,ibasin(icell)) = sumbas(5,ibasin(icell)) + 
     $              snowtoday * km2mm * area
               sumbas(6,ibasin(icell)) = sumbas(6,ibasin(icell)) + 
     $              snowwattoday * km2mm * area
           endif

c  Sum P and ET fluxes. Used in balance check in earlier model versions.
           sum_p = sum_p + precip*km2mm*area
           sum_et = sum_et + evap_merged*km2mm*area
           sum_runoff = sum_runoff + runoff_merged*km2mm*area
           sum_snowsubl = sum_snowsubl + snow_subl*km2mm*area

c  Sum all land water across all grid cells for balance check.  These
c     sums are not used in current version
c  Current version uses variables water4Land and terrestrialWater
           sum_snowpk = sum_snowpk + snowtoday*km2mm*area
           sum_wsnow = sum_wsnow + snowwattoday*km2mm*area
           sum_watbodystore = sum_watbodystore + 
     $          watbodystore *km2mm*area
           sum_soilwaterice = sum_soilwaterice +
     $          ( (soilwatNEW + soiliceNEW) *km2mm*area )
           sum_riverwater = sum_riverwater + riverwat

! get soil and snow water as a volume (km^3).
          water4Land = (snowtoday + snowwattoday + 
     $        soilwatNEW + soiliceNEW) * km2mm * area
          sum_water4Land = sum_water4Land + water4Land

c  Get the total water on the terrestrial surface. This is set up for
c   subgrid mosaicing.  It is a weighted average of the land water,
c   the lake/wetland water, plus the river water which is not weighted.
c   This assumes that the river channel is a constant non-varying size.
          terrestrialWater = ((water4Land)*fracLand(icell)) + 
     $    (watbodystore * km2mm*area * (1.0d0 - fracLand(icell))) +
     $       riverwater(icell)
          sum_TWS = sum_TWS + terrestrialWater  ! sum across all grids each day
          totjunk = (sum_p-sum_et-sum_runoff) - (sum_TWS-prev_TWS)

c  On 9th, there is no change in TWS because there is no P and no ET. Just 
c   a loss of water from soil water to runoff.

          if (iday .eq. lastday) then
             sumbas(4,ibasin(icell)) = sumbas(4,ibasin(icell)) + 
     $            terrestrialWater
          endif                                   ! use next for wat bal calc

 100     enddo    ! end of drainage cell loop, start from line 1050 
         !$OMP END DO
c         !$OMP END PARALLEL DO
c    **********************************************************************
c    ************************end of drainage cell loop ********************
c    **********************************************************************

         prev_TWS = sum_TWS
         prev_water4Land = sum_water4Land

         PminusE = sum_p - sum_et
         globe_cloud = globe_cloud - PminusE

! scale to thousandths of mm to avoid numerical overflow and thereby increase
!  accuracy of water balance check
         a = total_initial_water / 1.0d3
         b = globe_cloud / 1.0d3
         c = sum_TWS / 1.0d3
         d = sum_intrnl / 1.0d3    ! not calculated
         e = sum2ocean / 1.0d3     ! not calculated
         
         check = a - (b + c + d + e)   

         if (abs(check) .gt. 1.0d-3) then   
            write(*,*)' '
            write(*,*)'Domain water balance check failed'
            write(*,109)'Check should equal 0. Yet, check = ', check
            write(*,*)' '
            write(*,*)' initial water         Globalcloud     
     $ storage            internal basins        to-ocean        check' 
            write(*,108)imon,iday,total_initial_water,
     $      globe_cloud,sum_TWS, sum_intrnl, 
     $       sum2ocean, check
!            print*, total_initial_water, globe_cloud, sum_TWS
 108        format(2i5,8f18.8)
 109        format(a,f14.10)
            write(*,*)' '
            stop
         endif

cccccccccccc     DAILY OUTPUT SECTION ON LAST DAY OF EACH MONTH  cccccccc
cccccccccccc       Write daily values for chosen fields. cccccccccccccccc
      if (init.eq.nspinup+1 .and. iday .eq. lastday) then

      if (idailyout(2).eq.1) then
         fname =outpath(1:lengthout)//'pwbm_dailyrunoff.'
         dataname = 'PWBM daily runoff (mm); ' 
         call write_daily_data2(fname,rmissing2,dataname,iyr,imon,
     $                        ncells,runoff1,rlon,rlat) 
      endif

      if (idailyout(3).eq.1) then
         fname =outpath(1:lengthout)//'pwbm_dailybaseflow.'
         dataname = 'PWBM daily subsurface runoff (mm); ' 
         call write_daily_data2(fname,rmissing2,dataname,iyr,imon,
     $                        ncells,baseflow1,rlon,rlat) 
      endif      

      if (idailyout(7).eq.1) then
         fname =outpath(1:lengthout)//'pwbm_dailySWE.'
         dataname = 'PWBM daily SWE (mm); ' 
         call write_daily_data(fname,rmissing2,dataname,iyr,imon,
     $                        ncells,snowwateq1,rlon,rlat) 
      endif 
      
      fname =outpath(1:lengthout)//'pwbm_dailyDOC.'
      dataname = 'PWBM daily DOC yield (mg C m-2 day-1); ' 
      call write_daily_data2(fname,rmissing2,dataname,iyr,imon,
     $     ncells,DOC_stream,rlon,rlat)

      fname =outpath(1:lengthout)//'pwbm_dailysubDOC.'
      dataname = 'PWBM daily subsurface DOC (mg C m-2 day-1); ' 
      call write_daily_data2(fname,rmissing2,dataname,iyr,imon,
     $                        ncells,baseflowDOC1,rlon,rlat)

      fname =outpath(1:lengthout)//'pwbm_dailySWE.'
      dataname = 'PWBM daily snow melt (mm); '

      endif

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      enddo      ! end of day loop 
c    ******************************************************************
c    ***************** end of daily loop ******************************
c    ******************************************************************
    
      write(*,110) 'Year ', iyr,  ' processed'
 110  format(a,i4,a)

      if (init .eq. nspinup+1  
     $   .and. iyr .ge. ioutyr1 .and. imon .ge. ioutmon1 
     $   .and. iyr .le. ioutyr2 .and. imon .le. ioutmon2) then

c    the year to ouptut 
         write(yearstr, '(i4)') iyr
c  Precipitation
         fname = outpath(1:lengthout)//'pwbm_monthlyprcp'//yearstr
         dataname = ' monthly prcp, output from model; '
c         call write_mth_data(fname,dataname,iyr,ncells,monthprcp,
c     $                       rlon,rlat)

c  Evaporatranspiration
         if (monthlyout(1) .eq. 1) then 
             fname =  outpath(1:lengthout)//'pwbm_monthlyevap'//yearstr
             dataname = ' PWBM v1 monthly total ET(mm);  '
             call write_mth_data(fname,dataname,iyr,ncells,monthevap,
     $                      rlon,rlat) 
         endif

c  Runoff
         if (monthlyout(2) .eq. 1) then
             fname = outpath(1:lengthout)//'pwbm_monthlyrunoff'//yearstr
             dataname = 'PWBM v1 monthly runoff(mm); '
             call write_mth_data(fname,dataname,iyr,ncells,monthrunoff,
     $                      rlon,rlat)
         endif

c  Runoff
         if (monthlyout(3) .eq. 1) then
             fname =  outpath(1:lengthout)//'pwbm_monthlybaseflow'//
     $                yearstr
             dataname = 'PWBM v1 monthly baseflow(mm); '
             call write_mth_data(fname,dataname,iyr,ncells,
     $                      monthbaseflow,rlon,rlat)
         endif

c   snow depth and swe are daily averages. Also select soil values.
         do imth=1,12
             monthswe(1:ncells,imth) = monthswe(1:ncells,imth)/     
     $                               real(monlastday(imth))
             monthsnowdepth(1:ncells,imth)=monthsnowdepth(1:ncells,imth)
     $            /real(monlastday(imth))
             monthsoilval(1:ncells,imth) = monthsoilval(1:ncells,imth)
     $            /real(monlastday(imth))       
         enddo

c  SWE
         if (monthlyout(7) .eq. 1) then
            fname=outpath(1:lengthout)//'pwbm_monthlySWE'//yearstr
            dataname = 'PWBM v1 monthly SWE (mm);  '
            call write_mth_data(fname,dataname,iyr,ncells,monthswe,
     $                          rlon,rlat)
           
c snow depth
           fname=outpath(1:lengthout)//'pwbm_monthlySnowDepth'//yearstr
           dataname = ' PWBM v1 monthly snow depth(cm); '
           call write_mth_data(fname,dataname,iyr,ncells,monthsnowdepth,
     $                    rlon,rlat)  
        endif

c snow sublimation
        if (monthlyout(8) .eq. 1) then
            fname=outpath(1:lengthout)//'pwbm_monthlySubl'//yearstr
            dataname = ' PWBM monthly sublimation (mm); '
            call write_mth_data(fname,dataname,iyr,ncells,monthsub,
     $                       rlon,rlat)
         endif

      endif          ! end of monthly outputs


      enddo    
c    ****************************************************************
c    *****************end of year loop ******************************
c    ****************************************************************
      sum2ocean_alltime=sum2ocean_alltime+sum2ocean  !sum ocean dis. over time
      globe_cloud = globe_cloud + sum2ocean     ! Evaporate ocean every time
      sum2ocean = 0.0d0                         ! So, ocean is now empty
!      print*, sum2ocean, globe_cloud, sum2ocean_alltime 

      if (init .eq. nspinup+1) goto 600     
      if (init .ge. 2) print*, init, ' times through spinup loop'

      enddo    
c    ****************************************************************
c    ***************** end of spinup loop ***************************
c    ****************************************************************

c  Sum the variable storing each basins' total (over time) discharge.
c  Then compare this value to the total export for Arctic drainage
c  (sum2ocean_alltime) and the non_Arctic drainages (sum_intrnl)
c   yyh: the variables below actually were not calculated...

 600  print*, '******************************************************'
      print*, '********** Simulation sucessfully completed **********'
      print*, '******************************************************'

      stop
      end

