C#######################################################################
C#                                                                    ##
C#               PPPP   W           W  BBBBBB   M       M             ##
C#               P   P   W         W   B    B   MM     MM             ##
C#               PPPP     W   W   W    BBBBBB   M M   M M             ##
C#               P         W W W W     B    B   M  M M  M             ##
C#               P          W   W      BBBBBB   M   M   M             ##
C#                                                                    ##
C#                                                                    ##
C#                    PERMAFROST WATER BALANCE MODEL                  ##
C#                     +++++   Version 4.0   +++++                    ##
C# . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .##
C#                                                                    ##
C#                 PWBM VERSION 4.0 CAN BE OBTAINED AT:               ##
C#                                                                    ##
C#                  https://blogs.umass.edu/csrc/pwbm                 ##
C#                                                                    ##
C# . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .##
C#                                                                    ##
C#              *****  PWBM (v4) function: snowadjustment  *****      ##
C#    Function gets snow damming coefficient for cover type           ##
C#                                                                    ##
C#                                                                    ##
C#     NOTE:   See notes in PWBM main routine, file pwbmModel_v4.f    ##
C#                                                                    ##
c***********************************************************************
      
      real*8 function snowadj(icover)
c
c  Function to return value for snow damming coefficient.  This 
c  coefficient varies with cover type.  Cover type is an integer for 
c  one of the following:

c        Cover     Type

c         1      Ice
c         2      Polar Desert
c         3      Tundra
c         4      Forest-Tundra
c         5      Taiga/Boreal
c         6      Grassland/Steppe/Shrubland
c         7      Wetland 
c         8      Deciduous/Mixed Forest
c         9      Non-Arctic 
c        10      Lakes/Seas

      implicit none
      integer icover
      real*8 coeff(10)
      data coeff /0.85d0, 0.8d0, 0.8d0, 0.7d0, 0.4d0, 0.8d0, 0.9d0,
     $             0.4d0, 1.0d0, 1.0d0 /

      snowadj = coeff(icover)

      return
      end
