C#######################################################################
C#                                                                    ##
C#               PPPP   W           W  BBBBBB   M       M             ##
C#               P   P   W         W   B    B   MM     MM             ##
C#               PPPP     W   W   W    BBBBBB   M M   M M             ##
C#               P         W W W W     B    B   M  M M  M             ##
C#               P          W   W      BBBBBB   M   M   M             ##
C#                                                                    ##
C#                                                                    ##
C#                    PERMAFROST WATER BALANCE MODEL                  ##
C#                     +++++   Version 4.0   +++++                    ##
C# . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .##
C#                                                                    ##
C#                 PWBM VERSION 4.0 CAN BE OBTAINED AT:               ##
C#                                                                    ##
C#                  https://blogs.umass.edu/csrc/pwbm                 ##
C#                                                                    ##
C# . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .##
C#                                                                    ##
C#            *****  PWBM (v4) subroutine: conductivity_v4  *****     ##
C#  Subroutine calculates soil thermal conductivity as weighted avg   ##
C#                                                                    ##
C#                                                                    ##
C#     NOTE:   See notes in PWBM main routine, file pwbmModel_v4.f    ##
C#                                                                    ##
c***********************************************************************

	subroutine conductivity_v3(isoillayers,peat_fraction,porosity,
     $  thermcondmineral,thermcondpeat,thermcondair,dry_soil_thcnd,
     $  heatcapmineral,heatcappeat,heatcapair,dry_soil_heatc,
     $  iwrite)

      implicit none
      integer iwrite,ilayer,isoillayers
      real*8 thermcondmineral,thermcondpeat,thermcondair
      real*8 heatcapmineral,heatcappeat,heatcapair
      real*8 porosity(isoillayers),peat_fraction(isoillayers)
      real*8 thermcondlayer(isoillayers),dry_soil_thcnd(isoillayers)
      real*8 heatcaplayer(isoillayers),dry_soil_heatc(isoillayers)

      do ilayer = 1, isoillayers
         
c  Calculate thermal conductivity as a geometric average based on fraction
c  of peat in the layer.
            thermcondlayer(ilayer) = 
     $            thermcondpeat ** peat_fraction(ilayer) *
     $         thermcondmineral ** (1.0d0 - peat_fraction(ilayer))    
          
            dry_soil_thcnd(ilayer) = 
     $            thermcondlayer(ilayer) ** (1-porosity(ilayer)) *
     $            thermcondair ** porosity(ilayer)


		  heatcaplayer(ilayer) = 
     $            heatcappeat * peat_fraction(ilayer) +
     $         heatcapmineral * (1.0d0 - peat_fraction(ilayer))    
          
            dry_soil_heatc(ilayer) = 
     $            heatcaplayer(ilayer) * (1-porosity(ilayer)) +
     $            heatcapair * porosity(ilayer)
      enddo    ! end of loop over soil layers   

      return
      end
